net.corda.core.contracts.clauses

## Class GroupClauseVerifier<S extends ContractState,C extends CommandData,K>

- Clause
- - net.corda.core.contracts.clauses.GroupClauseVerifier<S,C,K>

- Direct Known Subclasses:
    Clauses.Group, Clauses.Group, Clauses.Group, Clauses.Group

      public class GroupClauseVerifier<S extends ContractState,C extends CommandData,K>
      extends Clause

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.corda.core.contracts.clauses.Clause

      `Clause.Companion`

  - ### Field Summary

    - ### Fields inherited from class net.corda.core.contracts.clauses.Clause

      `Companion`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GroupClauseVerifier(Clause<? super S,C,? super K> clause)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Clause<S,C,K>` | `getClause()`
    `java.util.List<net.corda.core.contracts.clauses.Clause>` | `getExecutionPath(java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends C>> commands)` Determine the subclauses which will be verified as a result of verifying this clause.
    `java.util.List<net.corda.core.contracts.TransactionForContract.InOutGroup>` | `groupStates(TransactionForContract tx)`
    `java.util.Set<C>` | `verify(TransactionForContract tx, java.util.List<? extends net.corda.core.contracts.ContractState> inputs, java.util.List<? extends net.corda.core.contracts.ContractState> outputs, java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends C>> commands, kotlin.Unit groupingKey)` Verify the transaction matches the conditions from this clause. For example, a "no zero amount output" clause would check each of the output states that it applies to, looking for a zero amount, and throw IllegalStateException if any matched.

    - ### Methods inherited from class net.corda.core.contracts.clauses.Clause

      `getExecutionPath, getRequiredCommands, verify`

- - ### Constructor Detail

    - #### GroupClauseVerifier

          public GroupClauseVerifier(Clause<? super S,C,? super K> clause)

  - ### Method Detail

    - #### groupStates

          public java.util.List<net.corda.core.contracts.TransactionForContract.InOutGroup> groupStates(TransactionForContract tx)

    - #### getExecutionPath

          public java.util.List<net.corda.core.contracts.clauses.Clause> getExecutionPath(java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends C>> commands)

      Determine the subclauses which will be verified as a result of verifying this clause.

      Throws:
        - if the given commands do not result in a valid execution (for example no match with `class FirstOf`).

    - #### verify

          public java.util.Set<C> verify(TransactionForContract tx,
                                         java.util.List<? extends net.corda.core.contracts.ContractState> inputs,
                                         java.util.List<? extends net.corda.core.contracts.ContractState> outputs,
                                         java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends C>> commands,
                                         kotlin.Unit groupingKey)

      Verify the transaction matches the conditions from this clause. For example, a "no zero amount output" clause would check each of the output states that it applies to, looking for a zero amount, and throw IllegalStateException if any matched.

      Parameters:
        `tx` - the full transaction being verified. This is provided for cases where clauses need to access states or commands outside of their normal scope.
        `inputs` - input states which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `outputs` - output states which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `commands` - commands which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `groupingKey` - a grouping key applied to states and commands, where applicable. Taken from `class TransactionForContract.InOutGroup`.
      Returns:
        the set of commands that are consumed IF this clause is matched, and cannot be used to match a later clause. This would normally be all commands matching "requiredCommands" for this clause, but some verify() functions may do further filtering on possible matches, and return a subset. This may also include commands that were not required (for example the Exit command for fungible assets is optional).

    - #### getClause

          public Clause<S,C,K> getClause()